diff --git a/src/backend/snowball/libstemmer/stem_UTF_8_turkish.c b/src/backend/snowball/libstemmer/stem_UTF_8_turkish.c
index 587351d126..85eee41ada 100644
--- a/src/backend/snowball/libstemmer/stem_UTF_8_turkish.c
+++ b/src/backend/snowball/libstemmer/stem_UTF_8_turkish.c
@@ -1817,66 +1733,66 @@ static int r_stem_noun_suffixes(struct SN_env * z) {
         goto lab0;
     lab31:
         z->c = z->l - m1;
-        z->ket = z->c; /* [, line 406 */
-        {   int ret = r_mark_lArI(z);
-            if (ret == 0) goto lab41; /* call mark_lArI, line 406 */
+        z->ket = z->c; /* [, line 404 */
+        {   int ret = r_mark_lArI(z); /* call mark_lArI, line 404 */
+            if (ret == 0) goto lab41;
             if (ret < 0) return ret;
         }
-        z->bra = z->c; /* ], line 406 */
-        {   int ret = slice_del(z); /* delete, line 406 */
+        z->bra = z->c; /* ], line 404 */
+        {   int ret = slice_del(z); /* delete, line 404 */
             if (ret < 0) return ret;
         }
         goto lab0;
     lab41:
         z->c = z->l - m1;
-        {   int ret = r_stem_suffix_chain_before_ki(z);
-            if (ret == 0) goto lab42; /* call stem_suffix_chain_before_ki, line 408 */
+        {   int ret = r_stem_suffix_chain_before_ki(z); /* call stem_suffix_chain_before_ki, line 406 */
+            if (ret == 0) goto lab42;
             if (ret < 0) return ret;
         }
         goto lab0;
     lab42:
         z->c = z->l - m1;
-        z->ket = z->c; /* [, line 410 */
-        {   int m12 = z->l - z->c; (void)m12; /* or, line 410 */
-            {   int ret = r_mark_DA(z);
-                if (ret == 0) goto lab45; /* call mark_DA, line 410 */
+        z->ket = z->c; /* [, line 408 */
+        {   int m22 = z->l - z->c; (void)m22; /* or, line 408 */
+            {   int ret = r_mark_DA(z); /* call mark_DA, line 408 */
+                if (ret == 0) goto lab45;
                 if (ret < 0) return ret;
             }
             goto lab44;
         lab45:
-            z->c = z->l - m12;
-            {   int ret = r_mark_yU(z);
-                if (ret == 0) goto lab46; /* call mark_yU, line 410 */
+            z->c = z->l - m22;
+            {   int ret = r_mark_yU(z); /* call mark_yU, line 408 */
+                if (ret == 0) goto lab46;
                 if (ret < 0) return ret;
             }
             goto lab44;
         lab46:
-            z->c = z->l - m12;
-            {   int ret = r_mark_yA(z);
-                if (ret == 0) goto lab43; /* call mark_yA, line 410 */
+            z->c = z->l - m22;
+            {   int ret = r_mark_yA(z); /* call mark_yA, line 408 */
+                if (ret == 0) goto lab43;
                 if (ret < 0) return ret;
             }
         }
     lab44:
-        z->bra = z->c; /* ], line 410 */
-        {   int ret = slice_del(z); /* delete, line 410 */
+        z->bra = z->c; /* ], line 408 */
+        {   int ret = slice_del(z); /* delete, line 408 */
             if (ret < 0) return ret;
         }
-        {   int m_keep = z->l - z->c;/* (void) m_keep;*/ /* try, line 410 */
-            z->ket = z->c; /* [, line 410 */
-            {   int m13 = z->l - z->c; (void)m13; /* or, line 410 */
-                {   int ret = r_mark_possessives(z);
-                    if (ret == 0) goto lab49; /* call mark_possessives, line 410 */
+        {   int m23 = z->l - z->c; (void)m23; /* try, line 408 */
+            z->ket = z->c; /* [, line 408 */
+            {   int m24 = z->l - z->c; (void)m24; /* or, line 408 */
+                {   int ret = r_mark_possessives(z); /* call mark_possessives, line 408 */
+                    if (ret == 0) goto lab49;
                     if (ret < 0) return ret;
                 }
-                z->bra = z->c; /* ], line 410 */
-                {   int ret = slice_del(z); /* delete, line 410 */
+                z->bra = z->c; /* ], line 408 */
+                {   int ret = slice_del(z); /* delete, line 408 */
                     if (ret < 0) return ret;
                 }
-                {   int m_keep = z->l - z->c;/* (void) m_keep;*/ /* try, line 410 */
-                    z->ket = z->c; /* [, line 410 */
-                    {   int ret = r_mark_lAr(z);
-                        if (ret == 0) { z->c = z->l - m_keep; goto lab50; } /* call mark_lAr, line 410 */
+                {   int m25 = z->l - z->c; (void)m25; /* try, line 408 */
+                    z->ket = z->c; /* [, line 408 */
+                    {   int ret = r_mark_lAr(z); /* call mark_lAr, line 408 */
+                        if (ret == 0) { z->c = z->l - m25; goto lab50; }
                         if (ret < 0) return ret;
                     }
                 lab50:
@@ -1884,20 +1800,20 @@ static int r_stem_noun_suffixes(struct SN_env * z) {
                 }
                 goto lab48;
             lab49:
-                z->c = z->l - m13;
-                {   int ret = r_mark_lAr(z);
-                    if (ret == 0) { z->c = z->l - m_keep; goto lab47; } /* call mark_lAr, line 410 */
+                z->c = z->l - m24;
+                {   int ret = r_mark_lAr(z); /* call mark_lAr, line 408 */
+                    if (ret == 0) { z->c = z->l - m23; goto lab47; }
                     if (ret < 0) return ret;
                 }
             }
         lab48:
-            z->bra = z->c; /* ], line 410 */
-            {   int ret = slice_del(z); /* delete, line 410 */
+            z->bra = z->c; /* ], line 408 */
+            {   int ret = slice_del(z); /* delete, line 408 */
                 if (ret < 0) return ret;
             }
-            z->ket = z->c; /* [, line 410 */
-            {   int ret = r_stem_suffix_chain_before_ki(z);
-                if (ret == 0) { z->c = z->l - m_keep; goto lab47; } /* call stem_suffix_chain_before_ki, line 410 */
+            z->ket = z->c; /* [, line 408 */
+            {   int ret = r_stem_suffix_chain_before_ki(z); /* call stem_suffix_chain_before_ki, line 408 */
+                if (ret == 0) { z->c = z->l - m23; goto lab47; }
                 if (ret < 0) return ret;
             }
         lab47:
@@ -1906,37 +1822,36 @@ static int r_stem_noun_suffixes(struct SN_env * z) {
         goto lab0;
     lab43:
         z->c = z->l - m1;
-        z->ket = z->c; /* [, line 412 */
-        {   int m14 = z->l - z->c; (void)m14; /* or, line 412 */
-            {   int ret = r_mark_possessives(z);
-                if (ret == 0) goto lab52; /* call mark_possessives, line 412 */
+        z->ket = z->c; /* [, line 410 */
+        {   int m26 = z->l - z->c; (void)m26; /* or, line 410 */
+            {   int ret = r_mark_possessives(z); /* call mark_possessives, line 410 */
+                if (ret == 0) goto lab52;
                 if (ret < 0) return ret;
             }
             goto lab51;
         lab52:
-            z->c = z->l - m14;
-            {   int ret = r_mark_sU(z);
-                if (ret == 0) return 0; /* call mark_sU, line 412 */
-                if (ret < 0) return ret;
+            z->c = z->l - m26;
+            {   int ret = r_mark_sU(z); /* call mark_sU, line 410 */
+                if (ret <= 0) return ret;
             }
         }
     lab51:
-        z->bra = z->c; /* ], line 412 */
-        {   int ret = slice_del(z); /* delete, line 412 */
+        z->bra = z->c; /* ], line 410 */
+        {   int ret = slice_del(z); /* delete, line 410 */
             if (ret < 0) return ret;
         }
-        {   int m_keep = z->l - z->c;/* (void) m_keep;*/ /* try, line 412 */
-            z->ket = z->c; /* [, line 412 */
-            {   int ret = r_mark_lAr(z);
-                if (ret == 0) { z->c = z->l - m_keep; goto lab53; } /* call mark_lAr, line 412 */
+        {   int m27 = z->l - z->c; (void)m27; /* try, line 410 */
+            z->ket = z->c; /* [, line 410 */
+            {   int ret = r_mark_lAr(z); /* call mark_lAr, line 410 */
+                if (ret == 0) { z->c = z->l - m27; goto lab53; }
                 if (ret < 0) return ret;
             }
-            z->bra = z->c; /* ], line 412 */
-            {   int ret = slice_del(z); /* delete, line 412 */
+            z->bra = z->c; /* ], line 410 */
+            {   int ret = slice_del(z); /* delete, line 410 */
                 if (ret < 0) return ret;
             }
-            {   int ret = r_stem_suffix_chain_before_ki(z);
-                if (ret == 0) { z->c = z->l - m_keep; goto lab53; } /* call stem_suffix_chain_before_ki, line 412 */
+            {   int ret = r_stem_suffix_chain_before_ki(z); /* call stem_suffix_chain_before_ki, line 410 */
+                if (ret == 0) { z->c = z->l - m27; goto lab53; }
                 if (ret < 0) return ret;
             }
         lab53:
@@ -1947,31 +1862,30 @@ lab0:
     return 1;
 }
 
-static int r_post_process_last_consonants(struct SN_env * z) {
+static int r_post_process_last_consonants(struct SN_env * z) { /* backwardmode */
     int among_var;
-    z->ket = z->c; /* [, line 416 */
-    among_var = find_among_b(z, a_23, 4); /* substring, line 416 */
+    z->ket = z->c; /* [, line 414 */
+    among_var = find_among_b(z, a_23, 4); /* substring, line 414 */
     if (!(among_var)) return 0;
-    z->bra = z->c; /* ], line 416 */
-    switch(among_var) {
-        case 0: return 0;
+    z->bra = z->c; /* ], line 414 */
+    switch (among_var) { /* among, line 414 */
         case 1:
-            {   int ret = slice_from_s(z, 1, s_16); /* <-, line 417 */
+            {   int ret = slice_from_s(z, 1, s_5); /* <-, line 415 */
                 if (ret < 0) return ret;
             }
             break;
         case 2:
-            {   int ret = slice_from_s(z, 2, s_17); /* <-, line 418 */
+            {   int ret = slice_from_s(z, 2, s_6); /* <-, line 416 */
                 if (ret < 0) return ret;
             }
             break;
         case 3:
-            {   int ret = slice_from_s(z, 1, s_18); /* <-, line 419 */
+            {   int ret = slice_from_s(z, 1, s_7); /* <-, line 417 */
                 if (ret < 0) return ret;
             }
             break;
         case 4:
-            {   int ret = slice_from_s(z, 1, s_19); /* <-, line 420 */
+            {   int ret = slice_from_s(z, 1, s_8); /* <-, line 418 */
                 if (ret < 0) return ret;
             }
             break;
@@ -1979,94 +1893,109 @@ static int r_post_process_last_consonants(struct SN_env * z) {
     return 1;
 }
 
-static int r_append_U_to_stems_ending_with_d_or_g(struct SN_env * z) {
-    {   int m_test = z->l - z->c; /* test, line 431 */
-        {   int m1 = z->l - z->c; (void)m1; /* or, line 431 */
-            if (!(eq_s_b(z, 1, s_20))) goto lab1;
+static int r_append_U_to_stems_ending_with_d_or_g(struct SN_env * z) { /* backwardmode */
+    {   int m_test1 = z->l - z->c; /* test, line 429 */
+        {   int m2 = z->l - z->c; (void)m2; /* or, line 429 */
+            if (z->c <= z->lb || z->p[z->c - 1] != 'd') goto lab1; /* literal, line 429 */
+            z->c--;
             goto lab0;
         lab1:
-            z->c = z->l - m1;
-            if (!(eq_s_b(z, 1, s_21))) return 0;
+            z->c = z->l - m2;
+            if (z->c <= z->lb || z->p[z->c - 1] != 'g') return 0; /* literal, line 429 */
+            z->c--;
         }
     lab0:
-        z->c = z->l - m_test;
+        z->c = z->l - m_test1;
     }
-    {   int m2 = z->l - z->c; (void)m2; /* or, line 433 */
-        {   int m_test = z->l - z->c; /* test, line 432 */
-            if (out_grouping_b_U(z, g_vowel, 97, 305, 1) < 0) goto lab3; /* goto */ /* grouping vowel, line 432 */
-            {   int m3 = z->l - z->c; (void)m3; /* or, line 432 */
-                if (!(eq_s_b(z, 1, s_22))) goto lab5;
+    {   int m3 = z->l - z->c; (void)m3; /* or, line 431 */
+        {   int m_test4 = z->l - z->c; /* test, line 430 */
+            if (out_grouping_b_U(z, g_vowel, 97, 305, 1) < 0) goto lab3; /* goto */ /* grouping vowel, line 430 */
+            {   int m5 = z->l - z->c; (void)m5; /* or, line 430 */
+                if (z->c <= z->lb || z->p[z->c - 1] != 'a') goto lab5; /* literal, line 430 */
+                z->c--;
                 goto lab4;
             lab5:
-                z->c = z->l - m3;
-                if (!(eq_s_b(z, 2, s_23))) goto lab3;
+                z->c = z->l - m5;
+                if (!(eq_s_b(z, 2, s_9))) goto lab3; /* literal, line 430 */
             }
         lab4:
-            z->c = z->l - m_test;
+            z->c = z->l - m_test4;
         }
-        {   int c_keep = z->c;
-            int ret = insert_s(z, z->c, z->c, 2, s_24); /* <+, line 432 */
-            z->c = c_keep;
+        {   int ret;
+            {   int saved_c = z->c;
+                ret = insert_s(z, z->c, z->c, 2, s_10); /* <+, line 430 */
+                z->c = saved_c;
+            }
             if (ret < 0) return ret;
         }
         goto lab2;
     lab3:
-        z->c = z->l - m2;
-        {   int m_test = z->l - z->c; /* test, line 434 */
-            if (out_grouping_b_U(z, g_vowel, 97, 305, 1) < 0) goto lab6; /* goto */ /* grouping vowel, line 434 */
-            {   int m4 = z->l - z->c; (void)m4; /* or, line 434 */
-                if (!(eq_s_b(z, 1, s_25))) goto lab8;
+        z->c = z->l - m3;
+        {   int m_test6 = z->l - z->c; /* test, line 432 */
+            if (out_grouping_b_U(z, g_vowel, 97, 305, 1) < 0) goto lab6; /* goto */ /* grouping vowel, line 432 */
+            {   int m7 = z->l - z->c; (void)m7; /* or, line 432 */
+                if (z->c <= z->lb || z->p[z->c - 1] != 'e') goto lab8; /* literal, line 432 */
+                z->c--;
                 goto lab7;
             lab8:
-                z->c = z->l - m4;
-                if (!(eq_s_b(z, 1, s_26))) goto lab6;
+                z->c = z->l - m7;
+                if (z->c <= z->lb || z->p[z->c - 1] != 'i') goto lab6; /* literal, line 432 */
+                z->c--;
             }
         lab7:
-            z->c = z->l - m_test;
+            z->c = z->l - m_test6;
         }
-        {   int c_keep = z->c;
-            int ret = insert_s(z, z->c, z->c, 1, s_27); /* <+, line 434 */
-            z->c = c_keep;
+        {   int ret;
+            {   int saved_c = z->c;
+                ret = insert_s(z, z->c, z->c, 1, s_11); /* <+, line 432 */
+                z->c = saved_c;
+            }
             if (ret < 0) return ret;
         }
         goto lab2;
     lab6:
-        z->c = z->l - m2;
-        {   int m_test = z->l - z->c; /* test, line 436 */
-            if (out_grouping_b_U(z, g_vowel, 97, 305, 1) < 0) goto lab9; /* goto */ /* grouping vowel, line 436 */
-            {   int m5 = z->l - z->c; (void)m5; /* or, line 436 */
-                if (!(eq_s_b(z, 1, s_28))) goto lab11;
+        z->c = z->l - m3;
+        {   int m_test8 = z->l - z->c; /* test, line 434 */
+            if (out_grouping_b_U(z, g_vowel, 97, 305, 1) < 0) goto lab9; /* goto */ /* grouping vowel, line 434 */
+            {   int m9 = z->l - z->c; (void)m9; /* or, line 434 */
+                if (z->c <= z->lb || z->p[z->c - 1] != 'o') goto lab11; /* literal, line 434 */
+                z->c--;
                 goto lab10;
             lab11:
-                z->c = z->l - m5;
-                if (!(eq_s_b(z, 1, s_29))) goto lab9;
+                z->c = z->l - m9;
+                if (z->c <= z->lb || z->p[z->c - 1] != 'u') goto lab9; /* literal, line 434 */
+                z->c--;
             }
         lab10:
-            z->c = z->l - m_test;
+            z->c = z->l - m_test8;
         }
-        {   int c_keep = z->c;
-            int ret = insert_s(z, z->c, z->c, 1, s_30); /* <+, line 436 */
-            z->c = c_keep;
+        {   int ret;
+            {   int saved_c = z->c;
+                ret = insert_s(z, z->c, z->c, 1, s_12); /* <+, line 434 */
+                z->c = saved_c;
+            }
             if (ret < 0) return ret;
         }
         goto lab2;
     lab9:
-        z->c = z->l - m2;
-        {   int m_test = z->l - z->c; /* test, line 438 */
-            if (out_grouping_b_U(z, g_vowel, 97, 305, 1) < 0) return 0; /* goto */ /* grouping vowel, line 438 */
-            {   int m6 = z->l - z->c; (void)m6; /* or, line 438 */
-                if (!(eq_s_b(z, 2, s_31))) goto lab13;
+        z->c = z->l - m3;
+        {   int m_test10 = z->l - z->c; /* test, line 436 */
+            if (out_grouping_b_U(z, g_vowel, 97, 305, 1) < 0) return 0; /* goto */ /* grouping vowel, line 436 */
+            {   int m11 = z->l - z->c; (void)m11; /* or, line 436 */
+                if (!(eq_s_b(z, 2, s_13))) goto lab13; /* literal, line 436 */
                 goto lab12;
             lab13:
-                z->c = z->l - m6;
-                if (!(eq_s_b(z, 2, s_32))) return 0;
+                z->c = z->l - m11;
+                if (!(eq_s_b(z, 2, s_14))) return 0; /* literal, line 436 */
             }
         lab12:
-            z->c = z->l - m_test;
+            z->c = z->l - m_test10;
         }
-        {   int c_keep = z->c;
-            int ret = insert_s(z, z->c, z->c, 2, s_33); /* <+, line 438 */
-            z->c = c_keep;
+        {   int ret;
+            {   int saved_c = z->c;
+                ret = insert_s(z, z->c, z->c, 2, s_15); /* <+, line 436 */
+                z->c = saved_c;
+            }
             if (ret < 0) return ret;
         }
     }
@@ -2074,12 +2003,23 @@ lab2:
     return 1;
 }
 
-static int r_more_than_one_syllable_word(struct SN_env * z) {
-    {   int c_test = z->c; /* test, line 446 */
+static int r_is_reserved_word(struct SN_env * z) { /* backwardmode */
+    if (!(eq_s_b(z, 2, s_16))) return 0; /* literal, line 440 */
+    {   int m1 = z->l - z->c; (void)m1; /* try, line 440 */
+        if (!(eq_s_b(z, 3, s_17))) { z->c = z->l - m1; goto lab0; } /* literal, line 440 */
+    lab0:
+        ;
+    }
+    if (z->c > z->lb) return 0; /* atlimit, line 440 */
+    return 1;
+}
+
+static int r_more_than_one_syllable_word(struct SN_env * z) { /* forwardmode */
+    {   int c_test1 = z->c; /* test, line 447 */
         {   int i = 2;
-            while(1) { /* atleast, line 446 */
-                int c1 = z->c;
-                {    /* gopast */ /* grouping vowel, line 446 */
+            while(1) { /* atleast, line 447 */
+                int c2 = z->c;
+                {    /* gopast */ /* grouping vowel, line 447 */
                     int ret = out_grouping_U(z, g_vowel, 97, 305, 1);
                     if (ret < 0) goto lab0;
                     z->c += ret;
@@ -2087,77 +2027,39 @@ static int r_more_than_one_syllable_word(struct SN_env * z) {
                 i--;
                 continue;
             lab0:
-                z->c = c1;
+                z->c = c2;
                 break;
             }
             if (i > 0) return 0;
         }
-        z->c = c_test;
+        z->c = c_test1;
     }
     return 1;
 }
 
-static int r_is_reserved_word(struct SN_env * z) {
-    {   int c1 = z->c; /* or, line 451 */
-        {   int c_test = z->c; /* test, line 450 */
-            while(1) { /* gopast, line 450 */
-                if (!(eq_s(z, 2, s_34))) goto lab2;
-                break;
-            lab2:
-                {   int ret = skip_utf8(z->p, z->c, 0, z->l, 1);
-                    if (ret < 0) goto lab1;
-                    z->c = ret; /* gopast, line 450 */
-                }
-            }
-            z->I[0] = 2;
-            if (!(z->I[0] == z->l)) goto lab1;
-            z->c = c_test;
-        }
-        goto lab0;
-    lab1:
-        z->c = c1;
-        {   int c_test = z->c; /* test, line 452 */
-            while(1) { /* gopast, line 452 */
-                if (!(eq_s(z, 5, s_35))) goto lab3;
-                break;
-            lab3:
-                {   int ret = skip_utf8(z->p, z->c, 0, z->l, 1);
-                    if (ret < 0) return 0;
-                    z->c = ret; /* gopast, line 452 */
-                }
-            }
-            z->I[0] = 5;
-            if (!(z->I[0] == z->l)) return 0;
-            z->c = c_test;
-        }
-    }
-lab0:
-    return 1;
-}
+static int r_postlude(struct SN_env * z) { /* forwardmode */
+    z->lb = z->c; z->c = z->l; /* backwards, line 451 */
 
-static int r_postlude(struct SN_env * z) {
-    {   int c1 = z->c; /* not, line 456 */
-        {   int ret = r_is_reserved_word(z);
-            if (ret == 0) goto lab0; /* call is_reserved_word, line 456 */
+    {   int m1 = z->l - z->c; (void)m1; /* not, line 452 */
+        {   int ret = r_is_reserved_word(z); /* call is_reserved_word, line 452 */
+            if (ret == 0) goto lab0;
             if (ret < 0) return ret;
         }
         return 0;
     lab0:
-        z->c = c1;
+        z->c = z->l - m1;
     }
-    z->lb = z->c; z->c = z->l; /* backwards, line 457 */
-
-    {   int m2 = z->l - z->c; (void)m2; /* do, line 458 */
-        {   int ret = r_append_U_to_stems_ending_with_d_or_g(z);
-            if (ret == 0) goto lab1; /* call append_U_to_stems_ending_with_d_or_g, line 458 */
+    {   int m2 = z->l - z->c; (void)m2; /* do, line 453 */
+        {   int ret = r_append_U_to_stems_ending_with_d_or_g(z); /* call append_U_to_stems_ending_with_d_or_g, line 453 */
+            if (ret == 0) goto lab1;
             if (ret < 0) return ret;
         }
     lab1:
         z->c = z->l - m2;
     }
-    {   int m3 = z->l - z->c; (void)m3; /* do, line 459 */
-        {   int ret = r_post_process_last_consonants(z);
-            if (ret == 0) goto lab2; /* call post_process_last_consonants, line 459 */
+    {   int m3 = z->l - z->c; (void)m3; /* do, line 454 */
+        {   int ret = r_post_process_last_consonants(z); /* call post_process_last_consonants, line 454 */
+            if (ret == 0) goto lab2;
             if (ret < 0) return ret;
         }
     lab2:
@@ -2167,39 +2069,37 @@ static int r_postlude(struct SN_env * z) {
     return 1;
 }
 
-extern int turkish_UTF_8_stem(struct SN_env * z) {
-    {   int ret = r_more_than_one_syllable_word(z);
-        if (ret == 0) return 0; /* call more_than_one_syllable_word, line 465 */
-        if (ret < 0) return ret;
+extern int turkish_UTF_8_stem(struct SN_env * z) { /* forwardmode */
+    {   int ret = r_more_than_one_syllable_word(z); /* call more_than_one_syllable_word, line 460 */
+        if (ret <= 0) return ret;
     }
-    z->lb = z->c; z->c = z->l; /* backwards, line 467 */
+    z->lb = z->c; z->c = z->l; /* backwards, line 462 */
 
-    {   int m1 = z->l - z->c; (void)m1; /* do, line 468 */
-        {   int ret = r_stem_nominal_verb_suffixes(z);
-            if (ret == 0) goto lab0; /* call stem_nominal_verb_suffixes, line 468 */
+    {   int m1 = z->l - z->c; (void)m1; /* do, line 463 */
+        {   int ret = r_stem_nominal_verb_suffixes(z); /* call stem_nominal_verb_suffixes, line 463 */
+            if (ret == 0) goto lab0;
             if (ret < 0) return ret;
         }
     lab0:
         z->c = z->l - m1;
     }
-    if (!(z->B[0])) return 0; /* Boolean test continue_stemming_noun_suffixes, line 469 */
-    {   int m2 = z->l - z->c; (void)m2; /* do, line 470 */
-        {   int ret = r_stem_noun_suffixes(z);
-            if (ret == 0) goto lab1; /* call stem_noun_suffixes, line 470 */
+    if (!(z->B[0])) return 0; /* Boolean test continue_stemming_noun_suffixes, line 464 */
+    {   int m2 = z->l - z->c; (void)m2; /* do, line 465 */
+        {   int ret = r_stem_noun_suffixes(z); /* call stem_noun_suffixes, line 465 */
+            if (ret == 0) goto lab1;
             if (ret < 0) return ret;
         }
     lab1:
         z->c = z->l - m2;
     }
     z->c = z->lb;
-    {   int ret = r_postlude(z);
-        if (ret == 0) return 0; /* call postlude, line 473 */
-        if (ret < 0) return ret;
+    {   int ret = r_postlude(z); /* call postlude, line 468 */
+        if (ret <= 0) return ret;
     }
     return 1;
 }
 
-extern struct SN_env * turkish_UTF_8_create_env(void) { return SN_create_env(0, 1, 1); }
+extern struct SN_env * turkish_UTF_8_create_env(void) { return SN_create_env(0, 0, 1); }
 
 extern void turkish_UTF_8_close_env(struct SN_env * z) { SN_close_env(z, 0); }
 
diff --git a/src/backend/snowball/libstemmer/utilities.c b/src/backend/snowball/libstemmer/utilities.c
index 8c89af1cd5..920b8dbe6d 100644
--- a/src/backend/snowball/libstemmer/utilities.c
+++ b/src/backend/snowball/libstemmer/utilities.c
@@ -1,7 +1,5 @@
 #include "header.h"
 
-#define unless(C) if(!(C))
-
 #define CREATE_SIZE 1
 
 extern symbol * create_s(void) {
@@ -10,7 +8,7 @@ extern symbol * create_s(void) {
     if (mem == NULL) return NULL;
     p = (symbol *) (HEAD + (char *) mem);
     CAPACITY(p) = CREATE_SIZE;
-    SET_SIZE(p, CREATE_SIZE);
+    SET_SIZE(p, 0);
     return p;
 }
 
@@ -22,7 +20,7 @@ extern void lose_s(symbol * p) {
 /*
    new_p = skip_utf8(p, c, lb, l, n); skips n characters forwards from p + c
    if n +ve, or n characters backwards from p + c - 1 if n -ve. new_p is the new
-   position, or 0 on failure.
+   position, or -1 on failure.
 
    -- used to implement hop and next in the utf8 case.
 */
@@ -85,14 +83,14 @@ static int get_b_utf8(const symbol * p, int c, int lb, int * slot) {
     if (b1 >= 0xC0 || c == lb) {   /* 1100 0000 */
         * slot = (b1 & 0x1F) << 6 | (b0 & 0x3F); return 2;
     }
-    * slot = (p[c] & 0xF) << 12 | (b1 & 0x3F) << 6 | (b0 & 0x3F); return 3;
+    * slot = (p[--c] & 0xF) << 12 | (b1 & 0x3F) << 6 | (b0 & 0x3F); return 3;
 }
 
 extern int in_grouping_U(struct SN_env * z, const unsigned char * s, int min, int max, int repeat) {
     do {
 	int ch;
 	int w = get_utf8(z->p, z->c, z->l, & ch);
-	unless (w) return -1;
+	if (!w) return -1;
 	if (ch > max || (ch -= min) < 0 || (s[ch >> 3] & (0X1 << (ch & 0X7))) == 0)
 	    return w;
 	z->c += w;
@@ -104,7 +102,7 @@ extern int in_grouping_b_U(struct SN_env * z, const unsigned char * s, int min,
     do {
 	int ch;
 	int w = get_b_utf8(z->p, z->c, z->lb, & ch);
-	unless (w) return -1;
+	if (!w) return -1;
 	if (ch > max || (ch -= min) < 0 || (s[ch >> 3] & (0X1 << (ch & 0X7))) == 0)
 	    return w;
 	z->c -= w;
@@ -116,8 +114,8 @@ extern int out_grouping_U(struct SN_env * z, const unsigned char * s, int min, i
     do {
 	int ch;
 	int w = get_utf8(z->p, z->c, z->l, & ch);
-	unless (w) return -1;
-	unless (ch > max || (ch -= min) < 0 || (s[ch >> 3] & (0X1 << (ch & 0X7))) == 0)
+	if (!w) return -1;
+	if (!(ch > max || (ch -= min) < 0 || (s[ch >> 3] & (0X1 << (ch & 0X7))) == 0))
 	    return w;
 	z->c += w;
     } while (repeat);
@@ -128,8 +126,8 @@ extern int out_grouping_b_U(struct SN_env * z, const unsigned char * s, int min,
     do {
 	int ch;
 	int w = get_b_utf8(z->p, z->c, z->lb, & ch);
-	unless (w) return -1;
-	unless (ch > max || (ch -= min) < 0 || (s[ch >> 3] & (0X1 << (ch & 0X7))) == 0)
+	if (!w) return -1;
+	if (!(ch > max || (ch -= min) < 0 || (s[ch >> 3] & (0X1 << (ch & 0X7))) == 0))
 	    return w;
 	z->c -= w;
     } while (repeat);
@@ -167,7 +165,7 @@ extern int out_grouping(struct SN_env * z, const unsigned char * s, int min, int
 	int ch;
 	if (z->c >= z->l) return -1;
 	ch = z->p[z->c];
-	unless (ch > max || (ch -= min) < 0 || (s[ch >> 3] & (0X1 << (ch & 0X7))) == 0)
+	if (!(ch > max || (ch -= min) < 0 || (s[ch >> 3] & (0X1 << (ch & 0X7))) == 0))
 	    return 1;
 	z->c++;
     } while (repeat);
@@ -179,7 +177,7 @@ extern int out_grouping_b(struct SN_env * z, const unsigned char * s, int min, i
 	int ch;
 	if (z->c <= z->lb) return -1;
 	ch = z->p[z->c - 1];
-	unless (ch > max || (ch -= min) < 0 || (s[ch >> 3] & (0X1 << (ch & 0X7))) == 0)
+	if (!(ch > max || (ch -= min) < 0 || (s[ch >> 3] & (0X1 << (ch & 0X7))) == 0))
 	    return 1;
 	z->c--;
     } while (repeat);
@@ -366,7 +364,7 @@ extern int replace_s(struct SN_env * z, int c_bra, int c_ket, int s_size, const
             if (z->c > c_bra)
                 z->c = c_bra;
     }
-    unless (s_size == 0) memmove(z->p + c_bra, s, s_size * sizeof(symbol));
+    if (s_size) memmove(z->p + c_bra, s, s_size * sizeof(symbol));
     if (adjptr != NULL)
         *adjptr = adjustment;
     return 0;
@@ -412,12 +410,7 @@ extern int insert_s(struct SN_env * z, int bra, int ket, int s_size, const symbo
 }
 
 extern int insert_v(struct SN_env * z, int bra, int ket, const symbol * p) {
-    int adjustment;
-    if (replace_s(z, bra, ket, SIZE(p), p, &adjustment))
-        return -1;
-    if (bra <= z->bra) z->bra += adjustment;
-    if (bra <= z->ket) z->ket += adjustment;
-    return 0;
+    return insert_s(z, bra, ket, SIZE(p), p);
 }
 
 extern symbol * slice_to(struct SN_env * z, symbol * p) {
@@ -450,6 +443,16 @@ extern symbol * assign_to(struct SN_env * z, symbol * p) {
     return p;
 }
 
+extern int len_utf8(const symbol * p) {
+    int size = SIZE(p);
+    int len = 0;
+    while (size--) {
+        symbol b = *p++;
+        if (b >= 0xC0 || b < 0x80) ++len;
+    }
+    return len;
+}
+
 #if 0
 extern void debug(struct SN_env * z, int number, int line_count) {
     int i;
diff --git a/src/include/snowball/libstemmer/header.h b/src/include/snowball/libstemmer/header.h
index 4d3078f50f..6bccf0f2c7 100644
--- a/src/include/snowball/libstemmer/header.h
+++ b/src/include/snowball/libstemmer/header.h
@@ -54,5 +54,7 @@ extern int insert_v(struct SN_env * z, int bra, int ket, const symbol * p);
 extern symbol * slice_to(struct SN_env * z, symbol * p);
 extern symbol * assign_to(struct SN_env * z, symbol * p);
 
+extern int len_utf8(const symbol * p);
+
 extern void debug(struct SN_env * z, int number, int line_count);
 
diff --git a/src/include/snowball/libstemmer/stem_ISO_8859_1_danish.h b/src/include/snowball/libstemmer/stem_ISO_8859_1_danish.h
index 49c5559cdf..57f16f8960 100644
--- a/src/include/snowball/libstemmer/stem_ISO_8859_1_danish.h
+++ b/src/include/snowball/libstemmer/stem_ISO_8859_1_danish.h
@@ -1,5 +1,5 @@
-
-/* This file was generated automatically by the Snowball to ANSI C compiler */
+/* This file was generated automatically by the Snowball to ISO C compiler */
+/* http://snowballstem.org/ */
 
 #ifdef __cplusplus
 extern "C" {
diff --git a/src/include/snowball/libstemmer/stem_ISO_8859_1_dutch.h b/src/include/snowball/libstemmer/stem_ISO_8859_1_dutch.h
index e67d11152c..5423842969 100644
--- a/src/include/snowball/libstemmer/stem_ISO_8859_1_dutch.h
+++ b/src/include/snowball/libstemmer/stem_ISO_8859_1_dutch.h
@@ -1,5 +1,5 @@
-
-/* This file was generated automatically by the Snowball to ANSI C compiler */
+/* This file was generated automatically by the Snowball to ISO C compiler */
+/* http://snowballstem.org/ */
 
 #ifdef __cplusplus
 extern "C" {
diff --git a/src/include/snowball/libstemmer/stem_ISO_8859_1_english.h b/src/include/snowball/libstemmer/stem_ISO_8859_1_english.h
index e685dcf7ef..d5a56a98f0 100644
--- a/src/include/snowball/libstemmer/stem_ISO_8859_1_english.h
+++ b/src/include/snowball/libstemmer/stem_ISO_8859_1_english.h
@@ -1,5 +1,5 @@
-
-/* This file was generated automatically by the Snowball to ANSI C compiler */
+/* This file was generated automatically by the Snowball to ISO C compiler */
+/* http://snowballstem.org/ */
 
 #ifdef __cplusplus
 extern "C" {
diff --git a/src/include/snowball/libstemmer/stem_ISO_8859_1_finnish.h b/src/include/snowball/libstemmer/stem_ISO_8859_1_finnish.h
index c67b67b944..ba197d8a70 100644
--- a/src/include/snowball/libstemmer/stem_ISO_8859_1_finnish.h
+++ b/src/include/snowball/libstemmer/stem_ISO_8859_1_finnish.h
@@ -1,5 +1,5 @@
-
-/* This file was generated automatically by the Snowball to ANSI C compiler */
+/* This file was generated automatically by the Snowball to ISO C compiler */
+/* http://snowballstem.org/ */
 
 #ifdef __cplusplus
 extern "C" {
